local modname = ...
local pp = package.path
package.path = ''
local M = require 'array'
package.path = pp
package.loaded[modname] = M
setmetatable(M, {__index = _G})
_ENV = M

function pack(a)
  local b = 0
  for i, v in ipairs(a) do
    if v ~= 0 then
      b = bit32.bor(b, bit32.lshift(1, i - 1))
    end
  end
  return b
end
