local modname = ...
local pp = package.path
package.path = ''
local M = require 'util'
package.path = pp
package.loaded[modname] = M
setmetatable(M, {__index = _G})
_ENV = M

function indices(first, last)
  local i = iclone(first)
  i[#i] = i[#i] - 1
  local k = #i
  return function()
    while k > 0 do
      i[k] = i[k] + 1
      if i[k] > last[k] then
        i[k] = first[k]
        k = k - 1
      else
        break
      end
    end
    if k > 0 then
      k = #i
      return i
    else
      return nil
    end
  end
end
